#ifndef _DTWDLL_H
#define _DTWDLL_H
/*** START HEADER FILE SPECIFICATIONS ********************************
**
** Source File Name = dtwdll.h
**
** Licensed Materials - Property of IBM
**
** (C) COPYRIGHT International Business Machines Corp. 1995
** All Rights Reserved.
**
** US Government Users Restricted Rights - Use, duplication or
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
**
** This is the header files for API support and Net.Commerce.
**
**** END HEADER FILE SPECIFICATIONS **********************************/

//
//
// Following data structure is used to pass the environment used by the
// netdata dll.
// The parameter "passed_env" passed to the entry point is of type
// "struct dtw_env_data" which is defined below.
//
#include <nl_types.h>      /* @A1 */
/* @tn1:  Do not call dtwdecl.h from dtwdll.h -- NT rule !
#include "dtwdecl.h"
*/

/*
 * LN01: this is declared in dtwdecl.h already.
 */
/*
#define MAX_ENV_DATA_LEN 1024

#ifndef NLS_STRUCT
#define NLS_STRUCT
typedef struct nls_struct {             // @A1
   int          convert_code_page;
   nl_catd      db2www_catd;  // the NLS descriptor
   int          system_cp;  // the default code page
} nls_struct_t;
#endif

#ifndef DTW_ENV_DATA
#define DTW_ENV_DATA
typedef struct dtw_env_data {
    int      net_commerce;  // only for Net.Commerce, this field should
                            // be set to 1 and 0 for others
    char     request_method[MAX_ENV_DATA_LEN];
    char     script_name[MAX_ENV_DATA_LEN];
    char*    new_query_string;
    int      new_query_string_len;
    char     new_path_info[MAX_ENV_DATA_LEN];
    char     new_path_trans[MAX_ENV_DATA_LEN];
    char*    pbuff;         // Handle to the print buffer.
    long     pbuff_len;     // Total print buffer size.
    char     content_type[MAX_ENV_DATA_LEN];
    char     content_length[MAX_ENV_DATA_LEN];
    char     server_port[MAX_ENV_DATA_LEN];
    char*    inputbuff;     // Handle to the input buffer.
    long     inputbuff_len; // Total input buffer size.
    void     *henv;         // store the ODBC env pointer for Net.Commerce
    void     *hdbc;         // store the ODBC database pointer for Net.Commerce
    void     *apiSession;   // store API specific handles
    void     *apiReq;       // additionl space for API specific
    nls_struct_t *nls_dataPtr; // pointer to nls data   // @A3

    char     *rawCookies;   // store the HTTP cookies from Web server  // @C2
} dtw_env_data_t;
#endif

*/

/* @tn1:  Applied Lynh's changes */
#define MAX_ENV_DATA_LEN 1024

#ifndef NLS_STRUCT
#define NLS_STRUCT
typedef struct nls_struct {             /* @A1 */
   int          convert_code_page;
   nl_catd      db2www_catd;  /* the NLS descriptor */
   int          system_cp;  /* the default code page */
} nls_struct_t;
#endif

#ifndef DTW_ENV_DATA
#define DTW_ENV_DATA
typedef struct dtw_env_data {
    int      net_commerce;  // only for Net.Commerce, this field should
                            // be set to 1 and 0 for others
    char     request_method[MAX_ENV_DATA_LEN];
    char     script_name[MAX_ENV_DATA_LEN];
    char*    new_query_string;
    int      new_query_string_len;
    char     new_path_info[MAX_ENV_DATA_LEN];
    char     new_path_trans[MAX_ENV_DATA_LEN];
    char*    pbuff;         // Handle to the print buffer.
    long     pbuff_len;     // Total print buffer size.
    char     content_type[MAX_ENV_DATA_LEN];
    char     content_length[MAX_ENV_DATA_LEN];
    char     server_port[MAX_ENV_DATA_LEN];
    char*    inputbuff;     // Handle to the input buffer.
    long     inputbuff_len; // Total input buffer size.
    void     *henv;         // store the ODBC env pointer for Net.Commerce
    void     *hdbc;         // store the ODBC database pointer for Net.Commerce
    void     *apiSession;   // store API specific handles
    void     *apiReq;       // additionl space for API specific
    nls_struct_t *nls_dataPtr; // pointer to nls data   /* @A3 */

    char     *rawCookies;   // store the HTTP cookies from Web server  // @C2
#ifdef __OS2__
	int      hanging_mode;  // LN01: set the process to hang
#endif // os2
} dtw_env_data_t;
#endif

//
// The following function signature is the entry point into netdata dll.
//
// Notice the dtwdll.h is only included when the BUILD_DLL flag is set.
#ifndef _DTWNETCOM
#if defined(XP_WIN32) && (defined(_NSAPI) || defined(_ISAPI) || defined(DTW_SERVLET))
__declspec( dllimport ) void* _db2www_entry(void* passed_env);
#elif _SOLARIS
extern "C" void* _db2www_entry(void * passed_env); /* @HH1 */
void clean_dtw_buffer(void *buffer);       /* NR @tn2 */
#else
extern "C" {
void* _db2www_entry(void* passed_env);
}
#endif
#elif NTVISUAL
__declspec( dllimport ) void* _db2www_entry(void* passed_env);
__declspec( dllimport ) void clean_dtw_buffer(void* buffer);       /* NR @tn2*/
#else                      // for Net.Commerce on AIX/OS2
   #ifdef _SOLARIS  /* @HH1 */ 
      extern "C" {   /* @HH1 */ 
         void *_db2www_entry(void* passed_env);  /* @HH1 */ 
         void clean_dtw_buffer(void *buffer);  /* @HH1 */ 
      }  /* @HH1 */ 
   #else  /* @HH1 */ 
      void *_db2www_entry(void* passed_env);  /* @HH1 */ 
      extern "C" {  /* @HH1 */ 
          void clean_dtw_buffer(void *buffer);       /* NR @tn1 @TTN1*/  /* @HH1 */ 
      }  /* @HH1 */ 
   #endif  /* @HH1 */ 
#endif
#ifndef NTVISUAL        /* @A4 */
extern "C" {
#endif
int init_nls(nls_struct_t *nls_data);   /* @A2 */
int get_iniFileName(char   *path_trans, char   *path_info, char **dtw_ini); /* @A5 */
#ifndef NTVISUAL
}
#endif

#endif // DTWDLL_H
